Program PLD2Hlp;
uses
 Objects, Memory, tpString, TextFile, RevPos, GetID, CRT;

type
 PIdxItem = ^TIdxItem;
 TIdxItem = record
  Topic: PString;
  Pos: Longint;
 end;

 PIdxColl = ^TIdxColl;     {Topic index collection}
 TIdxColl = Object(TSortedCollection)
  SCase: Boolean;
  function Compare(Key1, Key2: Pointer): Integer; virtual;
  procedure FreeItem(Item: Pointer); virtual;
 end;

 PNIdxColl = ^TNIdxColl;   {Topic pos collection}
 TNIdxColl = Object(TSortedCollection)
  SoftSort: Boolean;
  function Compare(Key1, Key2: Pointer): Integer; virtual;
  procedure FreeItem(Item: Pointer); virtual;
 end;

var
 T, O: Text;
 Idx, FIdx: PIdxColl;
 NIdx: PNIdxColl;
 ExcludeCats, Intlist, OutFile: String;

function TIdxColl.Compare(Key1, Key2: Pointer): Integer;
var
 S1, S2 : String[20];
begin
 if SCase then
  begin
   S1 := StUpCase(TIdxItem(Key1^).Topic^);
   S2 := StUpCase(TIdxItem(Key2^).Topic^);
  end
 else
  begin
   S1 := TIdxItem(Key1^).Topic^;
   S2 := TIdxItem(Key2^).Topic^;
  end;
 if S1 > S2 then Compare := 1
 else if S1 < S2 then Compare := -1
      else Compare := 0
end;

procedure TIdxColl.FreeItem(Item: Pointer);
begin
 if Item <> Nil then
  begin
   DisposeStr(TIdxItem(Item^).Topic);
   FreeMem(Item, SizeOf(TIdxItem));
  end;
end;

function TNIdxColl.Compare(Key1, Key2: Pointer): Integer;
var
 L1, L2 : Longint;
begin
 L1 := Longint(Key1) and $7fffffff;
 L2 := Longint(Key2) and $7fffffff;
 if L1 > L2 then Compare := 1
 else if L1 < L2 then Compare := -1
      else Compare := 0
end;

procedure TNIdxColl.FreeItem(Item: Pointer);
begin
end;


procedure DelChar(Ch: Char; var S: String);
var
 i: Byte;
begin
 i := 1;
 while i <= Length(S) do
  if S[i] = Ch then Delete(S, i, 1)
  else Inc(i);
end;

procedure AddTopicToIdx(Topic: String; Pos : Longint);
var
 IdxItem: PIdxItem;
 Cnt: Integer;
begin
 IdxItem := MemAlloc(SizeOf(TIdxItem));
 if IdxItem <> Nil then
  begin
   Topic := ReplaceChar(#255, ' ', Topic);
   DelChar('`', Topic);
   IdxItem^.Topic := NewStr(Topic);
   IdxItem^.Pos := Pos;
   if Not Idx^.Search(IdxItem, Cnt) then
    begin
     Cnt := Idx^.Count;
     Idx^.Insert(IdxItem);
     if Cnt = Idx^.Count then
      begin
       WriteLn('Out of memory');
       Halt;
      end;
    end
   else Idx^.FreeItem(IdxItem);
  end;
end;

procedure Index;
var
 T: Text;
 S: String;
 Size: Longint;
 PredPos, TopicPos:  Longint;
begin
 Assign(T, Intlist);
 Reset(T);
 Size := TextFileSize(T);
 WriteLn('Creating index');
 PredPos := 0; TopicPos := 0;
 while not eof(T) do
  begin
   PredPos := TextPos(T);
   ReadLn(T, S);
   Write((PredPos * 100.0)/Size:-3:0,'%  '#13);
   if (Pos(':', S) = 1) then {NewTopic}
    begin
     NIdx^.Insert(Pointer(PredPos));
     repeat
      TopicPos := TextPos(T);
      ReadLn(T, S);
     until Pos(':', S) <> 1;
     TextSeek(T, PredPos);
     repeat
      ReadLn(T, S);

      if Pos(':', S) = 1 then AddTopicToIdx(Copy(S, 2, 255), TopicPos);
     until Pos(':', S) <> 1;
     NIdx^.Insert(Pointer(TopicPos));
    end;
  end;
 NIdx^.Insert(Pointer(Size));
 Close(T);
end;

function Convert(S : String): String;
begin
 S := ReplaceChar(':', '', S);
 S := ReplaceChar('{', '', S);
 S := ReplaceChar('}', '', S);
 Convert := S;
end;

function See(S: String): String;
var
 IdxItem: TIdxItem;
 PIdxItem: ^TIdxItem;
 Cnt: Integer;
 ps, ps1: Byte;
begin
 if Pos('<.#', S) = 1 then
  begin
   while (S[1] <> ' ') and (S <> '') do Delete(S, 1, 1);
   Delete(S, 1, 1);
   DelChar('>', S);
  end;
 ps := Pos('<', S);
 ps1 := Pos('>', S);
 if (ps <> 0) and (ps1 <> 0) then
  begin
   Dec(S[0]);
   Delete(S, 1, 1);
   PIdxItem := MemAlloc(SizeOf(TIdxItem));
   if PIdxItem <> Nil then
    begin
     PIdxItem^.Topic := NewStr(S);
     PIdxItem^.Pos := 0;
     if not FIdx^.Search(PIdxItem, Cnt) then FIdx^.Insert(PIdxItem)
     else FIdx^.FreeItem(PIdxItem);
     See := '{' + S + ':F_'+ ReplaceChar('.', '_', S) + '}';
    end;
  end
 else
  begin
   IdxItem.Topic := @S;
   if Idx^.Search(@IdxItem, Cnt) then
    See := '{' + Convert(S) + ':T' + HexL(TIdxItem(Idx^.At(Cnt)^).Pos) + '}'
   else See := '{' + Convert(S) + ':Color_2}';
  end;
end;

procedure CreateOutFile;
var
 O: Text;
begin
 Assign(O, OutFile);
 Rewrite(O);
 Close(O);
end;

procedure CreateIndex;
var
 I, J, Lines, Next: Integer;
 ps, ps1: Byte;
 Item: TIdxItem;
 EndTopic, CurPos, PredPos : Longint;
 T, O: Text;
 S, SS, TT: String;
begin
 Assign(O, OutFile);
 Append(O);
 WriteLn('Creating index topic');
 PredPos := 0;
 Lines := 0; Next := 0;
 WriteLn(O, '.topic Index');
 for I := 0 to Idx^.Count-1 do
  begin
   Item := PIdxItem(Idx^.At(I))^;
   Write((100.0 * I)/Idx^.Count:-3:0, '%  '#13);
   WriteLn(O, ' {', Convert(Item.Topic^), ':T', HexL(Item.Pos), '}');
   Inc(Lines);
   if Lines > 700 then
    begin
     Inc(Next);  Lines := 0;
     WriteLn(O, '{Next...:I_', Next, '}');
     WriteLn(O, '.topic I_', Next);
     if Next = 1 then WriteLn(O, '{Previous...:Index}')
     else WriteLn(O, '{Previous...:I_', Next - 1, '}');
    end;
  end;
 Close(O);
 Writeln('Done.');
end;

procedure CreateCrossReferenses;
var
 I, J, Lines, Next: Integer;
 ps, ps1: Byte;
 Item: TIdxItem;
 EndTopic, CurPos, PredPos : Longint;
 T, O: Text;
 S, SS, TT: String;
begin
 Assign(T, Intlist);
 Reset(T);
 Assign(O, OutFile);
 Append(O);
 WriteLn('Creating crossreferences');
 PredPos := 0;
 for I := 0 to Idx^.Count-1 do
  begin
   Item := PIdxItem(Idx^.At(I))^;
   Write((100.0 * I)/Idx^.Count:-3:0, '%  '#13);
   if not NIdx^.Search(Pointer(Item.Pos), J) then Exit;
   if (J+1) < NIdx^.Count then EndTopic := Longint(NIdx^.At(J+1)) and $7fffffff;

   if Longint(NIdx^.Items^[J]) and $80000000 <> 0 then Continue;
   Longint(NIdx^.Items^[J]) := Longint(NIdx^.Items^[J]) or $80000000;

   WriteLn(O, '.topic T', HexL(Item.Pos));
   WriteLn(O, ';', Item.Pos);
   WriteLn(O, ' {', Item.Topic^, ':Color_2}');
   WriteLn(O);

   TextSeek(T, Item.Pos);

   Lines := 0; Next := 0;
   repeat
    if Lines > 700 then
     begin
      Inc(Next);  Lines := 0;
      WriteLn(O, '{Next...:T' ,HexL(Item.Pos), '_', Next, '}');
      WriteLn(O, '.topic T' ,HexL(Item.Pos), '_', Next);
      if Next = 1 then WriteLn(O, '{Previous...:T' ,HexL(Item.Pos), '}')
      else WriteLn(O, '{Previous...:T' ,HexL(Item.Pos), '_', Next - 1, '}');
     end;
    ReadLn(T, S);
    if S <> '' then S := ReplaceChar(#255, ' ', S);
    DelChar('`', S);
    CurPos := TextPos(T);
    if (CurPos <= EndTopic) then
     begin
      repeat
       ps := Pos('~', S);
       if ps <> 0 then
       begin
        ps1 := FIPos('~', S, ps);
        if ps1 <> 0 then
         begin
          SS := See(SCopy(S, ps+1, ps1));
          Delete(S, Ps, Ps1 - Ps + 1);
          Insert(SS, S, Ps);
         end;
       end;
      until (ps = 0) or (ps1 = 0);
       WriteLn(O, ' ' + S);
       Inc(Lines);
     end;
   until eof(T) or (CurPos > EndTopic);
  end;
 WriteLn;
 Close(T);
 Close(O);
 Writeln('Done.');
end;

procedure CreateFilesTopics;
var
 I, J, Lines, Next: Integer;
 ps, ps1: Byte;
 Item: TIdxItem;
 EndTopic, CurPos, PredPos : Longint;
 T, O: Text;
 S, SS, TT: String;
begin
 Assign(O, OutFile);
 Append(O);
 WriteLn('Creating files topics');
 for I := 0 to FIdx^.Count-1 do
  begin
   Item := PIdxItem(FIdx^.At(I))^;
   Write((100.0 * I)/FIdx^.Count:-3:0, '%  '#13);
   WriteLn(O, '.topic F_' + ReplaceChar('.', '_', Item.Topic^));
   WriteLn(O, ' $Execute-');
   WriteLn(O, ' $XW($GET($CN\HELP\PLD.INI>Path)', Item.Topic^, ')');
   WriteLn(O);
  end;
 Close(O);
 Writeln('Done.');
end;

begin
 if ParamCount < 2 then Halt;
 IntList := ParamStr(1); OutFile := ParamStr(2);
 Idx := New(PIdxColl, Init(10, 10));
 Idx^.SCase := True;
 FIdx := New(PIdxColl, Init(10, 10));
 NIdx := New(PNIdxColl, Init(16300, 0));
 Idx^.Duplicates := True;
 Index;
 Writeln('Done. ', Idx^.Count, '/', NIdx^.Count, ' topics founded.');

 CreateOutFile;

 CreateIndex;

 CreateCrossReferenses;

 CreateFilesTopics;

 Dispose(NIdx, Done);
 Dispose(FIdx, Done);
 Dispose(Idx, Done);
 Writeln('Done.');
end.
